package com.eyefodder.flexcover
{
	import com.allurent.coverage.runtime.ICoverageAgent;
	import com.eyefodder.flexcover.agents.AgentFactory;
	
	import flash.desktop.NativeApplication;
	import flash.events.InvokeEvent;
	import flash.utils.getQualifiedClassName;
	
	import mx.logging.ILogger;
	import mx.logging.Log;

	/** the intent of this class is to act as a conduit to pass coverage requests to wherever they are needed.
	 * For example - if you have a local connection (as in the default, then messages are passed through a lcoal connection
	 * otherwise, they might be stored in memory to then write out to a file when done
	 */ 
	
	public class CoverageAgentSwitch implements ICoverageAgent
	{
		
		private var agentImpl:ICoverageAgent;
		private var coverageStack:Array;
		private var log:ILogger
		
		
		public function CoverageAgentSwitch()
		{
			coverageStack = [];
			log = Log.getLogger(getQualifiedClassName(this).replace("::","."));
			NativeApplication.nativeApplication.addEventListener(InvokeEvent.INVOKE, onAppInvoked);
		}
		
		private function onAppInvoked(evt:InvokeEvent):void{
			NativeApplication.nativeApplication.removeEventListener(InvokeEvent.INVOKE, onAppInvoked);
			var args:Array = evt.arguments;
			agentImpl = AgentFactory.getAgent(args);
			flushCoverageStack();
		}
		
		private function flushCoverageStack():void{
			for each (var key:String in coverageStack){
				recordCoverage(key);
			}
			coverageStack = null;
		}

		public function recordCoverage(key:String):void
		{
			//trace(key);
			if(agentImpl!=null){
				agentImpl.recordCoverage(key);
			}else{
				// Coverage calls that happen before the invoke event is called are stored here.
				// this stack gets flushed after an agent is initialised
				coverageStack.push(key);
			}
		}
		
		public function exit():void
		{
			agentImpl.exit();
		}
		
	}
}