package com.eyefodder.flexcover.agents
{
	import com.allurent.coverage.runtime.ICoverageAgent;
	import com.allurent.coverage.runtime.LocalConnectionCoverageAgent;
	
	import flash.utils.getQualifiedClassName;
	
	import mx.logging.ILogger;
	import mx.logging.Log;
	
	public class AgentFactory
	{
		
		private static const agentSwitch:String = "-coverage-agent-type=";
		
		private static var __logger:ILogger;
		
		// wull return an ICOverageAgent depending on commandline agrgs
		public static function getAgent(args:Array):ICoverageAgent{
			var agentClass:Class = LocalConnectionCoverageAgent;
			var token:String = getAgentToken(args) 
			if(token!= null){
				switch(token){
					case "headless":
						agentClass = HeadlessCoverageAgent;
						break;
				}
			}
			logger.debug("creating agent of type "+getQualifiedClassName(agentClass));
			return new agentClass();
		}
		
		public static function getAgentToken(args:Array):String{
			var outStr:String;
			var testStr:String;
			for (var i:int=0;i<args.length;++i){
				testStr = args[i];
				if(testStr.indexOf(agentSwitch)==0){
					outStr = testStr.substr(agentSwitch.length);
					break;
				}
			}
			
			return outStr;
		}
		
		private static function get logger():ILogger{
			if(__logger==null){
				__logger = Log.getLogger(getQualifiedClassName(AgentFactory).replace("::","."));
			}
			return __logger;	
		}

	}
}