package com.eyefodder.flexcover.parse
{
	
	import com.eyefodder.flexcover.model.CommandLineOptionsModel;
	
	import flash.filesystem.File;
	
	public class CommandLineOptionsParser
	{
		public function CommandLineOptionsParser()
		{
		}
		
		public function parse(args:Array):CommandLineOptionsModel{
			var vo:CommandLineOptionsModel = new CommandLineOptionsModel();
			var result:ParsedResult;
			for each (var arg:String in args)
            {
            	result = ParsedResult.create(arg);
            	if(result != null){
            		switch(result.name){
            			case "-coverage-metadata":
            				vo.metadataFile = createFile(result.value);
            				break;
            			case "-coverage-output":
            				vo.coverageReportCVRFormat = createFile(result.value);
            				break;
            			case "-emma-report":
            				vo.coverageReportEMMAFormat = createFile(result.value);
            				break;
            		}
            	}
            	
            }
			
			
			return vo;
		}
		
		private function createFile(val:String):File{
			var path:String = getFilePath(val);;
			return new File(path);
		}
		private function getFilePath(val:String):String{
			//strip quotes - not convinced this is necessary
			var char0:String = val.charAt(0);
			var outVal:String = val;
			if(char0=="'" || char0=="\"" && val.charAt(val.length-1)==char0){
				outVal = val.substr(1,val.length-2);
			}
			return outVal;
		}

	}
}

class ParsedResult{
	public var name:String;
	public var value:String;
	
	public function ParsedResult(theName:String, theValue:String){
		name = theName;
		value = theValue;
	} 
	
	public static function create(str:String):ParsedResult{
		var eqIndex:int = str.indexOf("=");
		var result:ParsedResult;
		var name:String;
		var value:String;
		if(eqIndex != -1){
			name = str.substring(0,eqIndex);
			value = str.substr(eqIndex+1);
			result = new ParsedResult(name,value);
		}
		return result;
	}
	
	
}